
import os
import logging

INIT = False
logger = logging.getLogger(__name__)

if os.path.exists('data'):
    DATA_DIR = 'data/'
elif os.path.exists('../data'):
    DATA_DIR = '../data/'
elif os.path.exists('/usr/local/share/blam'):
    DATA_DIR = '/usr/local/share/blam/'
elif os.path.exists('/usr/share/blam'):
    DATA_DIR = '/usr/local/share/blam/'
   



INI_PATH = os.path.join(DATA_DIR, 'comics.ini')
CONFIG_DIR = os.path.join( os.getenv('HOME'), '.config', 'blam/')
FAVICONS_DIR = os.path.join( CONFIG_DIR,'favicons/')

DB_PATH = os.path.join( CONFIG_DIR,'blam_database.db')
COMIC_DIR = os.path.join( CONFIG_DIR,'comics/')

_folders = [CONFIG_DIR, FAVICONS_DIR, COMIC_DIR]

def create_folders():
    for folder in _folders:
        if not os.path.isdir(folder):
            os.mkdir(folder)
            
def get_comic_folder(comic):
    path = os.path.join(COMIC_DIR, str(comic.get('id')) + "/")
    if not os.path.isdir(path):
            os.mkdir(path)
    return path

