import gtk, logging
import pubsub, blamobjects
from dialogs import NewTagDialog
import session


logger = logging.getLogger(__name__)

class ContextMenu(gtk.Menu):
    def __init__(self):
        gtk.Menu.__init__(self)
    
    def show(self, event):
       self.show_all()
       self.popup(None, None, None, event.button, event.get_time())


class MaintreeContextMenu(ContextMenu):
    def __init__(self, object = None):
        ContextMenu.__init__(self)
        add = gtk.MenuItem('Add new tag')
        add.connect('activate',  self.__add_tag)
        self.append(add)
        s = session.get_session()
        self.object = object
        remove = gtk.MenuItem("Remove Tag")
        if isinstance(self.object, blamobjects.Tag):
            remove.connect("activate", self._makeRemoveCallback(object))
            
        else:   
            remove_submenu = gtk.Menu()
            
            for tag in s['model'].Tags:
                item = gtk.MenuItem(tag.Name)
                item.connect("activate", self._makeRemoveCallback(tag))
                remove_submenu.append(item)
            remove.set_submenu(remove_submenu)
        self.append(remove)
       
    def _makeRemoveCallback(self, tag):
        return lambda x: self.__remove_tag(tag)
        
    def __remove_tag(self, tag):
        logger.debug('removing tag '+tag.Name)
        pubsub.publish('Tag.Removed', tag)
        
    def __add_tag(self, widget):
        NewTagDialog().start()

                
class ComicContextMenu(ContextMenu): 
    def __init__(self, comic = None):
        ContextMenu.__init__(self)
        self.comic = comic
       
        add = gtk.MenuItem("Add Tag")
        self.append(add)
        add_submenu = gtk.Menu()
        
        s = session.get_session()
        # temporary
        load = gtk.MenuItem("Download Comics")
        self.append(load)
        load.connect("activate", self._loadComicCallback(comic))
        
        if len(self.comic._tags) > 0:
            remove = gtk.MenuItem("Remove Tag")
            remove_submenu = gtk.Menu()
            self.append(remove)
            for tag in self.comic._tags:
                item = gtk.MenuItem(tag.Name)
                item.connect("activate", self._makeRemoveCallback(tag))
                remove_submenu.append(item)
            remove.set_submenu(remove_submenu)
        
        #das laesst sich sicher in einer zeile machen... habs net hin bekommen
        other_tags = []
        for tag in s['model'].Tags:
            if tag not in self.comic._tags:
                other_tags.append(tag)

        for tag in other_tags:
            item = gtk.MenuItem(tag.Name)
            item.connect("activate", self._makeAddCallback(tag))
            add_submenu.append(item)
          
        add.set_submenu(add_submenu)
        
    
    def _makeAddCallback(self, tag):
        return lambda x: self.add_tag(tag)
        
    def _makeRemoveCallback(self, tag):
        return lambda x: self.remove_tag(tag)
        
    def _loadComicCallback(self, comic):
        return lambda x: self.load_comic(comic)

    def remove_tag(self, tag):
        logger.debug('removing tag '+tag.Name+' from comic '+self.comic.Name)
        print "TODO"
        #db_controller.remove_tag_of_comic(self.comic, tag)
    
    def add_tag(self, tag):
        logger.debug('adding tag '+tag.Name+' to comic '+self.comic.Name)
        print "TODO"
        #db_controller.set_tag_of_comic(self.comic, tag)
        
    def load_comic(self, comic):
        logger.debug('Loading Comic ' + comic.Name)
        threadController.loadComic(comic)
