try:
    import sys, os, logging
    import gtk
    import gtk.glade
    import blam
    import main
    import config
except ImportError, e:
    logging.getLogger().error("Import error in dialogs:" + str(e))
    sys.exit(1)


class Dialog(object):
    def __init__(self):
        pass

    def start(self):
        """run the dialog"""
        break_out = False
        while (not break_out):
            result = self.run()
            if (result==gtk.RESPONSE_OK):
                #Save the date to the object because the user pressed ok.
                self.process_ok()
                break_out = True
            else:
                break_out = True
        self.destroy()
        return result;


class NewTagDialog(gtk.Dialog, Dialog):
    def __init__(self):
        gtk.Dialog.__init__(self, "Add new tag",None,
                     gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,
                      gtk.STOCK_OK, gtk.RESPONSE_OK))
        self.entry = gtk.Entry()   
        vbox = self.get_content_area()
        vbox.pack_start(self.entry)
        self.entry.show_all()

    def process_ok(self):
        tag = self.entry.get_text()
        if tag:
            main.session['model'].createTag(tag)


class AboutDialog(gtk.AboutDialog, Dialog):
    def __init__(self):
        gtk.AboutDialog.__init__(self)
        self.set_name(blam.__appname__)
        self.set_version(blam.__version__)
        self.set_copyright(blam.__copyright__)
        self.set_license(blam.__license__)
        self.set_authors(blam.__authors__)
        self.set_website(blam.__url__)
        self.set_logo(gtk.gdk.pixbuf_new_from_file(config.DATA_DIR+"blam.png"))
    
