import os, logging
import http, config


logger = logging.getLogger(__name__)


def download_favicon(request,comic):
    #print "starting request callable: ", request.requestID
    url = comic.get('favicon')
    if url:
        logger.debug("Getting favicon from " + url + " ...")
        favicon = http.download_image(url)
        f = config.FAVICONS_DIR + str(comic.get('id'))
        file = open(f, "w")
        file.write(favicon.read())
        file.close()
        logger.debug("Favicon: " + url +" downloaded and saved.")
        return True
    else:
        logger.info('no favicon url')
        return False


def get_favicon(comic):
    f = config.FAVICONS_DIR + str(comic.ID)
    if not os.path.isfile(f):
        #print "favicon not found: ", f
        logging.getLogger().info("favicon not found: " + f)
        logging.getLogger().info('Favicon Download disabled')
        #if comic.get('favicon'):
        #    threadController.get_favicon(comic)
        return config.DATA_DIR+"blam_icon_64_64.png"
    return f
