#!/bin/env python
try:
    import pygtk
    pygtk.require("2.0")
except:
    pass


import sys
import gtk
import logging
import os
import blam, gobject

import treeviews, context_menus, config, blamobjects, pubsub, menubar, imageview,blamstore
import  toolbars

import session

logger = logging.getLogger(__name__)




class MainWindow(gtk.Window):
    
    def __init__(self):
        # Create the toplevel window
        gtk.Window.__init__(self)
        self.connect("destroy", lambda x: gtk.main_quit())
        self.set_title(blam.__name__)
        self.set_icon_from_file(config.DATA_DIR+'blam.png')
        s = session.get_session()

        # Use two thirds of the screen by default
        screen = self.get_screen()
        monitor = screen.get_monitor_geometry(0)
        width = int(monitor.width * 0.66)
        height = int(monitor.height * 0.66)
        self.set_default_size(width, height)

        vbox = gtk.VBox()
        self.add(vbox)
    
        vbox.pack_start(menubar.MenuBar(), expand=False, fill=False)
 
        vbox.pack_start(toolbars.MainToolbar(), expand=False, fill=False)

        hpaned = gtk.HPaned()
        hpaned.set_position(int(width*0.15))
        vbox.pack_start(hpaned)

        main_tree = treeviews.MainTree()
        hpaned.pack1(main_tree)
        s['mainTree'] = main_tree

        comic_vbox = gtk.VBox()
        hpaned.pack2(comic_vbox)
        vpaned = gtk.VPaned()
        vpaned.set_position(int(height*0.3))
        comic_vbox.pack_start(vpaned)


        scrolled_window1 = gtk.ScrolledWindow()
        scrolled_window1.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        scrolled_window2 = gtk.ScrolledWindow()
        scrolled_window2.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        vpaned.add1(scrolled_window1)
        vpaned.add2(scrolled_window2)
        
        
        comic_tree = treeviews.ComicTree()
        scrolled_window1.add_with_viewport(comic_tree)
        s['comicTree'] = comic_tree

        scrolled_window2.add_with_viewport(imageview.ImageView())
        #Comic Toolbar
        comic_vbox.pack_start(toolbars.ComicToolbar() , expand=False, fill=False)

        statusbar = gtk.Statusbar()
        vbox.pack_start(statusbar, expand=False, fill=False)
        self.show_all()

    def reload_from_data(self):
        """Called when we want to reset everything based
        on internal data."""
        s = session.get_session()
        s['mainTree'].clear()
        s['comicTree'].clear()
        s['mainTree'].insert_categories()
        tags = s['model'].Tags
        for tag in tags:
            s['mainTree'].insert_tag(tag.Name, tag)
            #print tag.toString()



def main():
   
    config.create_folders()
    main_window = MainWindow()
    s = session.get_session()
    s['mainWindow']   = main_window
    s['store']        = blamstore.BlamStore(config.DB_PATH)
    s['model']        = s['store'].blamModel
    #Get the local path
    local_path = os.path.realpath(os.path.dirname(sys.argv[0]))
    main_window.reload_from_data()
    
   
    gobject.threads_init()
    gtk.main()


if __name__ == "__main__":
    logging.basicConfig(level=logging.DEBUG, 
         format="%(levelname)s %(asctime)s %(funcName)s %(lineno)d %(message)s")
    main()
