import gtk
import dialogs
import main
from webbrowser import open
import logging

logger = logging.getLogger(__name__)

def build_menu(menu_items):
    menu = gtk.Menu()
    
    for label,icon, func in menu_items:
        if label == '----':
            s = gtk.SeparatorMenuItem()
            s.show()
            menu.add(s)

        else:
            
            if icon is not None:
                item = gtk.ImageMenuItem(icon)
                item.get_children()[0].set_label(label)
            else:
                item = gtk.MenuItem(label) 
            
            if func is not None:
                item.connect("activate", func)
            item.show()
            menu.add(item)
    return menu

                      

class MenuBar(gtk.MenuBar):
    def __init__(self):
        gtk.MenuBar.__init__(self)

        file_menu_items = (('----'  , None, None),
                           ("Quit", gtk.STOCK_QUIT, lambda w: main.session['mainWindow'].destroy()),
                           )
        help_menu_items = (("Help"  , gtk.STOCK_HELP, None),
                            ("Website", None, lambda x:open("https://launchpad.net/blam")),
                            ("Request a Feature", None, lambda x:open("https://blueprints.launchpad.net/blam")),
                            ("Report a Bug", None, lambda x:open("https://bugs.launchpad.net/blam")),
                            ('----', None, None),
                           ("About", gtk.STOCK_ABOUT , self.on_about),
                           )

        filemenu = gtk.MenuItem("File")
        filemenu.set_submenu(build_menu(file_menu_items))

        helpmenu = gtk.MenuItem("Help")
        helpmenu.set_submenu(build_menu(help_menu_items))

        self.append(filemenu)
        self.append(helpmenu)
    

    def on_about(self, widget):
        dialogs.AboutDialog().start()
