from config import *
import favicons
from threadpool import WorkRequest
import logging
import http
import locale
import threadpool

pool = ThreadPool(5)
logger = logging.getLogger(__name__)

def get_favicon(comic):
    #print "SJDKLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL"
    request = WorkRequest(favicons.download_favicon, [comic], callback = get_favicon_callback)
    #logger.debug('Putting new Request: ' + str(request))
    pool.putRequest(request)


def get_favicon_callback(request, result):
    comic = request.args[0]
    iconviews.update_favicon(comic)

def load_comic(comic):
    for c in Comic.get_all_from_database():
        print c.get('name'), http.get_urls_for_comic(c)
    
    
### FRESH START ###
def loadComic(comic):
    urls = http.get_urls_for_comic(comic)
    type = comic.get('navType')
    if type == "number":
        print "Trying to download number type comic"
        #print urls
        #print comic.get('imgUrl')
        #print comic.toString()
        #print comic.get('firstNumber')
        #print urls
        for (number,url) in _make_number_downloads(comic, urls):
            response = http.download_image(url)
            #print "response for ", url
            #print response
            if response:
                #print dir(response)
                #print response.info()
                #print response
                fileType = _get_filetype_from_response_info(response.info())
                f = _make_file_for_strip(comic, number, fileType)
                f.write(response.read())
                f.close()
                logging.getLogger().debug('Saved image ' + str(number) + " of comic " + str(comic))
                strip = _make_strip(comic, number, url)
                print strip
                print strip.toString()
            else:
                logging.getLogger().debug('No response for image ' + str(number) + " of comic " + str(comic))
    else:
        logging.getLogger().error("Unimplemented Navigation Type: " + str(type))
        
def _make_strip(comic, number, url):
    # hier mit comic id und number pruefen, ob es die hure schon gibt
    strip = Strip.get_not_new(comic, number)
    strip.dressTuple(('number', number))
    strip.dressTuple(('comicID', comic.get('id')))
    strip.dressTuple(('URL', url))
    strip.put()
    return strip
        
def _make_file_for_strip(comic, number, fileType):
    print "making file for Strip number ", number, " of comic ", comic
    baseDir = get_comic_folder(comic)
    filePath = baseDir + str(number) + "." + fileType
    f = open(filePath, "w")
    return f
        
def _make_number_downloads(comic, urls):
    first = locale.atoi(comic.get('firstNumber'))
    last = locale.atoi(urls['numberRegex'][0])
    #print type(last)
    #print first, last
    #print comic.toString()
    result = []
    for i in range(first,last+1):
        result.append((i,comic.get('imgUrl').replace('$n',_format(i))))
    return result
        
def _format(number):
    if number > 99:
        return str(number)
    elif number > 9:
        return "0" + str(number)
    else:
        return "00" + str(number)
        
DELIMITER = 'Content-Type:'
        
def _get_filetype_from_response_info(info):
    #print info.getmaintype()
    subtype = info.getsubtype()
    return subtype

