import logging
import gtk
import dialogs



logger = logging.getLogger(__name__)

class ComicToolbar(gtk.Toolbar):
    def __init__(self):
        gtk.Toolbar.__init__(self)
        first = gtk.ToolButton('gtk-goto-first')
        prev = gtk.ToolButton('gtk-go-back')
        next = gtk.ToolButton('gtk-go-forward')
        last = gtk.ToolButton('gtk-goto-last')
        first.set_label('First')
        prev.set_label('Previous')
        next.set_label('Next')
        last.set_label('Last')
        first.connect('clicked', self.on_first_clicked)
        prev.connect('clicked', self.on_prev_clicked)
        next.connect('clicked', self.on_next_clicked)
        last.connect('clicked', self.on_last_clicked)
        self.insert(first, 0)
        self.insert(prev, 1)
        self.insert(next, 2)
        self.insert(last, 3)
        
    def on_first_clicked(self, widget):
        '''FIXME'''
        logger.debug('todo: load first comic')

    def on_prev_clicked(self, widget):
        '''FIXME'''
        logger.debug('todo: load previous comic')

    def on_next_clicked(self, widget):
        '''FIXME'''
        logger.debug('todo: load next comic')

    def on_last_clicked(self, widget):
        '''FIXME'''
        logger.debug('todo: load last comic')


class MainToolbar(gtk.Toolbar):
    def __init__(self):
        gtk.Toolbar.__init__(self)
        button = gtk.ToolButton('gtk-add')
        button.set_label('Add new tag')
        button.connect('clicked', self.on_addTag_clicked)
        self.insert(button,-1)
    
    def on_addTag_clicked(self, widget):
        dialogs.NewTagDialog().start()

