try:
    import sys, os, logging
    import gtk
    import gtk.glade
    import main
    import config
    import session
except ImportError, e:
    logging.getLogger().error("Import error in dialogs:" + str(e))
    sys.exit(1)

class Dialog(object):
    def __init__(self):
        pass

    def start(self):
        """run the dialog"""
        break_out = False
        while (not break_out):
            result = self.run()
            if (result==gtk.RESPONSE_OK):
                #Save the date to the object because the user pressed ok.
                self.process_ok()
                break_out = True
            else:
                break_out = True
        self.destroy()
        return result


class NewTagDialog(gtk.Dialog, Dialog):
    def __init__(self):
        gtk.Dialog.__init__(self, "Add new tag",None,
                     gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,
                      gtk.STOCK_OK, gtk.RESPONSE_OK))
        self.entry = gtk.Entry()
        self.connect('key-press-event', self.on_key_press_event)
        vbox = self.get_content_area()
        vbox.pack_start(self.entry)
        self.entry.show_all()
    
    
    def on_key_press_event(self, widget, event):
        '''Catch pressing Enter keys.'''
        keyname = gtk.gdk.keyval_name(event.keyval)

        enter_keynames = ('Return', 'KP_Enter')

        if keyname in enter_keynames:
            self.process_ok()
            self.destroy()
            return gtk.RESPONSE_OK


    def process_ok(self):
        tag = self.entry.get_text()
        if tag:
            s = session.get_session()
            s['model'].createTag(tag)


class AboutDialog(gtk.AboutDialog, Dialog):
    def __init__(self):
        gtk.AboutDialog.__init__(self)
        self.set_name(main.__appname__)
        self.set_version(main.__version__)
        self.set_copyright(main.__copyright__)
        self.set_license(main.__license__)
        self.set_authors(main.__authors__)
        self.set_website(main.__url__)
        self.set_logo(gtk.gdk.pixbuf_new_from_file(config.DATA_DIR+"blam.png"))
    
