import logging
import gtk
import dialogs
import pubsub
import session


logger = logging.getLogger(__name__)

class ComicToolbar(gtk.Toolbar):
    def __init__(self):
        gtk.Toolbar.__init__(self)
        first = gtk.ToolButton('gtk-goto-first')
        prev = gtk.ToolButton('gtk-go-back')
        ran = gtk.ToolButton('gtk-refresh')
        next = gtk.ToolButton('gtk-go-forward')
        last = gtk.ToolButton('gtk-goto-last')
        web = gtk.ToolButton('gtk-goto-last')
        zoom_in = gtk.ToolButton('gtk-zoom-in')
        zoom_out = gtk.ToolButton('gtk-zoom-out')
        first.set_label('First')
        prev.set_label('Previous')
        ran.set_label('Random')
        next.set_label('Next')
        last.set_label('Last')
        web.set_label('Website')
        zoom_in.set_label('Zoom in')
        zoom_in.set_label('Zoom out')
        first.connect('clicked', lambda x: pubsub.publish("comic.first"))
        prev.connect('clicked', lambda x: pubsub.publish("comic.previous"))
        next.connect('clicked', lambda x: pubsub.publish("comic.next"))
        last.connect('clicked', lambda x: pubsub.publish("comic.last"))
        ran.connect('clicked', lambda x: pubsub.publish("comic.random"))
        zoom_in.connect('clicked', lambda x: pubsub.publish("comic.zoom_in"))
        zoom_out.connect('clicked', lambda x: pubsub.publish("comic.zoom_out"))
        
        self.insert(first, 0)
        self.insert(prev, 1)
        self.insert(ran, 2)
        self.insert(next, 3)
        self.insert(last, 4)
        #self.insert(gtk.SeparatorToolItem(), 5)
        #self.insert(zoom_in, 6)
        #self.insert(zoom_out, 7)
        #self.insert(gtk.SeparatorToolItem(), 8)
        #self.insert(web, 6)
        
         


class TagToolbar(gtk.Toolbar):
    def __init__(self):
        gtk.Toolbar.__init__(self)
        button = gtk.ToolButton('gtk-add')
        button.set_label('Add new tag')
        button.connect('clicked', self.on_addTag_clicked)
        self.insert(button,-1)
        
        button = gtk.ToolButton('gtk-delete')
        button.set_label('Remove Tag')
        button.connect('clicked', self.on_removeTag_clicked)
        self.insert(button,-1)
    
    def on_addTag_clicked(self, widget):
        dialogs.NewTagDialog().start()
    
    def on_removeTag_clicked(self, widget):
        s = session.get_session()
        if s['mainTree'].selected_item:
            tag = s['mainTree'].selected_item[0]
            s['model'].removeTag(tag)

